> For the complete documentation index, see [llms.txt](https://developer.magtek.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.magtek.com/sdks-and-tools/universal-sdk-documentation/ios/mtusdkdelegate-delegate.md).

# MTUSDKDelegate Delegate

MTUniversal API will invoke the callback function in this chapter to provide the requested data and/or a detailed response. To delegate the event, implements the MTUSDKDelegate interface.

### onDeviceList <a href="#id-14.1_ondevicelist" id="id-14.1_ondevicelist"></a>

Handles BLE Service and EA Service events. Use this to find a BLE device or EA accessory.

{% code overflow="wrap" %}

```
(void) onDeviceList: (id) instance
withConnectionType: (MTU_ConnectionType) connectionType 
        deviceList: (NSArray<IDevice *> *) deviceList;
```

{% endcode %}

<table data-header-hidden><thead><tr><th width="229.9090576171875" valign="top"></th><th valign="top"></th></tr></thead><tbody><tr><td valign="top">Parameter</td><td valign="top">Description</td></tr><tr><td valign="top">instance</td><td valign="top">Instance identifier.</td></tr><tr><td valign="top">withConnectionType</td><td valign="top">Enumerated connection type.</td></tr><tr><td valign="top">deviceList</td><td valign="top">Array of devices.</td></tr></tbody></table>

Return Value: None

### didSystemUpdateState <a href="#id-14.2_didsystemupdatestate" id="id-14.2_didsystemupdatestate"></a>

Handles update of host system state.

{% code overflow="wrap" %}

```
(void) onDeviceList: (SystemState) state;
```

{% endcode %}

<table data-header-hidden><thead><tr><th width="180.8182373046875" valign="top"></th><th valign="top"></th></tr></thead><tbody><tr><td valign="top">Parameter</td><td valign="top">Description</td></tr><tr><td valign="top">state</td><td valign="top">Enumerated system state.</td></tr></tbody></table>

Return Value: None


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developer.magtek.com/sdks-and-tools/universal-sdk-documentation/ios/mtusdkdelegate-delegate.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
